%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% World Trade Model with Transport
% by Anders Stromman and Faye Duchin
%
% Programmed by
% Anders Hammer Stromman
% October 10 2006
%
% This Matlab file calls GAMS and is a sequential procedure 
% for running the World Trade Model with Transportation 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Identity matrix generation 
% and construction of logic set to avoid import-export from and to same region 
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Generating I matrix from dimensions of n -number of goods
I=eye(n_max);

% Generating identity matrix from dimensions of i -number of regions
IJ=eye(i_max);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Produce list of sets for GAMS
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Post declaration 
pd = cell(1,1);
pd{1,1} = 'SETS';

%Set declaration
sd_i = cell(1,1);
sd_n = cell(1,1);
sd_k = cell(1,1);
sd_i{1,1} = 'i regions';
sd_n{1,1} = 'n goods'; 
sd_k{1,1} = 'k factors';

%Total lines
slsh = cell(1,1);
slsh{1,1} = '/';

%Table Assembly
cellset = [pd;sd_i;slsh;i_set;slsh;sd_n;slsh;n_set;slsh;sd_k;slsh;k_set;slsh];
tabsize = size(cellset,1);

% Delete old file

delete set.gms

%Write File
fid = fopen('set.gms','w');
for line = 1:tabsize
fprintf(fid,'%s\n',char(cellset(line,:)));
end
status = fclose(fid);