%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% World Trade Model with Transport
% by Anders Stromman and Faye Duchin
%
% Programmed by
% Anders Hammer Stromman
% October 10 2006
%
% This Matlab file calls GAMS and is a sequential procedure 
% for running the World Trade Model with Transportation 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Setting GAMS Flags
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Setting GAMS output mode
gams_output = 'std';


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Section A - No Trade Model
% The first step is to run the No Trade Model to Establish no trade prices
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[x_nt, f_nt, p_nt, z_nt] = NoTradeModel(A, Y, F, PI);

% Prepering No-trade Prices for export to GAMS. Generating structures.

P_nt = ones(size(n_set,1), size(i_set,1));

%Solving E from no trade model
for r = 1:i_max
    E(:,r) = F(:,:,r) * x_nt(:,r);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Section B - World Trade Model With zero Transposrtation costs
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

delete matdata.gms
delete matglobs.gms

tic
% Prepering Data for export to GAMS. Generating structures.
sPI=mat2gams('PI',PI,{k_set,i_set});
sF=mat2gams('F',F,{k_set,n_set,i_set});
sA=mat2gams('A',A,{n_set,n_set,i_set});
sE=mat2gams('E',E,{k_set,i_set});
sY=mat2gams('Y',Y,{n_set,i_set});
%sTz=mat2gams('T',Tz,{n_set,n_set,i_set,i_set}); 
sT=mat2gams('T',T,{n_set,n_set,i_set,i_set}); 
sI=mat2gams('ID',I,{n_set,n_set});
sIJ=mat2gams('IJ',IJ,{i_set,i_set});
%sS=mat2gams('S',S,{n_set});
sP_nt=mat2gams('P_nt',P_nt,{n_set,i_set});
toc

tic
% Calling GAMS to solve the Trade Model BOT minimizing z and retrieving solution variables 
% NO BOT 
% wait(timer('Period',2.0));
%[P_bot_z_zt,z_bot_z_zt,x_bot_z_zt,ex_bot_z_zt,r_bot_z_zt,u_bot_z_zt]=gams('wtm_gm_200_12_z_gn_k',sPI,sF,sA,sE,sFL,sY,sT,sP_nt,sI,sIJ);
[P_bot_z_zt,z_bot_z_zt,x_bot_z_zt,ex_bot_z_zt,r_bot_z_zt]=gams('wtm_gm_200_12_z_gn',sPI,sF,sA,sE,sY,sT,sP_nt,sI,sIJ);
%[P_bot_z_zt,z_bot_z_zt,x_bot_z_zt,ex_bot_z_zt]=gams('wtm_gm_200_12_z_gn_mod',sPI,sF,sA,sE,sY,sT,sP_nt,sI,sIJ);

toc
%co2_bot_z_zt;
tic
alpha_bot_z_zt = zeros(size(i_set));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Section C - World Trade Model With Transposrtation
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%delete matdata.gms
%delete matglobs.gms

% Prepering Data for export to GAMS. Generating structures.
%sPI=mat2gams('PI',PI,{k_set,i_set});
%sF=mat2gams('F',F,{k_set,n_set,i_set});
%sA=mat2gams('A',A,{n_set,n_set,i_set});
%sE=mat2gams('E',E,{k_set,i_set});
%sY=mat2gams('Y',Y,{n_set,i_set});
%sT=mat2gams('T',T,{n_set,n_set,i_set,i_set});
%sI=mat2gams('ID',I,{n_set,n_set});
%sIJ=mat2gams('IJ',IJ,{i_set,i_set});
%sS=mat2gams('S',S,{n_set});
%sP_nt=mat2gams('P_nt',P_nt,{n_set,i_set});


% Calling GAMS to solve the Trade Model BOT minimizing z and retrieving solution variables 
% NO BOT 
% wait(timer('Period',2.0));
%[P_bot_z,z_bot_z,co2_bot_z,x_bot_z,ex_bot_z,r_bot_z,alpha_bot_z]= gams('wtm_gm_200_12_z',sPI,sF,sA,sE,sY,sT,sP_nt,sI,sIJ,sS);
P_bot_z_z = P_bot_z_zt;
z_bot_z_z = z_bot_z_zt;
%co2_bot_z_z = co2_bot_z_zt;
x_bot_z_z = x_bot_z_zt;
ex_bot_z_z = ex_bot_z_zt;
r_bot_z_z = r_bot_z_zt;
alpha_bot_z = alpha_bot_z_zt;

% x_nt = x_bot_z_zt; 
% f_nt = PI;
% z_nt = z_bot_z_zt; 
toc